# React Unique Hooks

A collection of custom hooks designed to enhance your day-to-day React web development experience. These hooks aim to simplify various aspects of React application development and can be seamlessly integrated into any React project to cater to individual needs.

## Installation

To incorporate `react-unique-hooks` into your project, begin by installing it via `npm` or `yarn`.

Using npm:

```bash
npm install react-unique-hooks
```

Using yarn:

```bash
yarn add react-unique-hooks
```

## Available Hooks

This package provides a range of custom hooks that can be utilized in your React applications. Below is a comprehensive list of the hooks currently available:

- useToggle
- useTimeout
- useDebounce
- useUpdateEffect
- useArray
- usePrevious
- useStateWithHistory
- useStorage
- useAsync
- useFetch
- useScript
- useDeepCompareEffect
- useEventListener
- useOnScreen
- useWindowSize
- useMediaQuery
- useGeolocation
- useStateWithValidation
- useSize
- useEffectOnce
- useClickOutside
- useDarkMode
- useCopyToClipboard
- useCookie
- useTranslation
- useOnlineStatus
- useRenderCount
- useDebugInformation
- useHover
- useLongPress

## Contributing

Contributions to the `react-unique-hooks` package are welcome and encouraged! If you find a bug or want to suggest an improvement, feel free to open an issue or submit a pull request on the [GitHub repository](https://github.com/shivamdevs/npm-packages/tree/main/react-unique-hooks).

## License

The `react-unique-hooks` package is licensed under the [MIT License](https://github.com/shivamdevs/npm-packages/tree/main/react-unique-hooks/LICENSE).
