/// <reference types="react" />
import { Callback } from "../../util";
export type StorageTypeHook = "localStorage" | "sessionStorage";
type StorageDefault<T> = (() => T) | T | undefined;
export type StorageHook<T> = [
    T | undefined,
    React.Dispatch<React.SetStateAction<T | undefined>>,
    Callback
];
export default function useStorage<T>(key: string, defaultValue: StorageDefault<T>, storage: StorageTypeHook): StorageHook<T>;
export declare function useLocalStorage<T>(key: string, defaultValue?: StorageDefault<T>): StorageHook<T>;
export declare function useSessionStorage<T>(key: string, defaultValue?: StorageDefault<T>): StorageHook<T>;
export {};
