"use client";
import { useCallback, useState, useMemo } from "react";
import win from "../../util/window";
import useDebounce from "../useDebounce";
import useInterval from "../useInterval";
export default function useStorage(key, defaultValue, storage) {
    var storageObject = useMemo(function () { return win === null || win === void 0 ? void 0 : win[storage]; }, []);
    var fetcher = useCallback(function () {
        var jsonValue = storageObject === null || storageObject === void 0 ? void 0 : storageObject.getItem(key);
        try {
            if (jsonValue !== null)
                return JSON.parse(jsonValue !== null && jsonValue !== void 0 ? jsonValue : "{}");
        }
        catch (e) {
        }
        finally {
            if (typeof defaultValue === "function") {
                return defaultValue();
            }
            else {
                return defaultValue;
            }
        }
    }, []);
    var _a = useState(function () { return fetcher(); }), value = _a[0], setValue = _a[1];
    var _b = useState(value), passValue = _b[0], setPassValue = _b[1];
    useDebounce(function () {
        if (value === undefined) {
            storageObject === null || storageObject === void 0 ? void 0 : storageObject.removeItem(key);
        }
        else {
            storageObject === null || storageObject === void 0 ? void 0 : storageObject.setItem(key, JSON.stringify(value));
        }
        setPassValue(value);
    }, 100, [key, value, storageObject]);
    useInterval(function () {
        if (!storageObject)
            return;
        setValue(function () { return fetcher(); });
    }, 100);
    var remove = useCallback(function () {
        setValue(undefined);
    }, []);
    return [passValue, setValue, remove];
}
export function useLocalStorage(key, defaultValue) {
    return useStorage(key, defaultValue, "localStorage");
}
export function useSessionStorage(key, defaultValue) {
    return useStorage(key, defaultValue, "sessionStorage");
}
